﻿{$H-}
unit SigMasLoader1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,System.Variants,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, Menus, Printers,Math,
  Winapi.Windows,Vcl.ComCtrls, ShellApi;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;



implementation

{$R *.DFM}

var
  hdll:THandle;
Const
  SIGMASDLL = 'SIGMASDLL.dll'#0;


Type

    ArrayType        = Array[1..40000] of byte;                                                  //RED Added (03/17/15)
    ArraySIntType    = Array[1..20000] of SmallInt;
    ArrayIntType     = Array[1..10000] of Integer;
    HeaderType       = Array[1..8] of byte;

Function SM_DLLVer:PANSIChar;   cdecl;   EXTERNAL SIGMASDLL;
Function SM_Initialize(DSPProgram:ShortString):Integer; cdecl;    EXTERNAL SIGMASDLL;
Function SM_Close:Integer;   cdecl;    EXTERNAL SIGMASDLL;
Function SM_DSPFuncTx(FuncNum,Count:Integer):Integer;   cdecl;    EXTERNAL SIGMASDLL;
Function SM_GetByteArray(var A:ArrayType; Count:Integer):Integer;     cdecl;    EXTERNAL SIGMASDLL;
Function SM_GetSIntArray(var A:ArraySIntType; Count:Integer):Integer;  cdecl;    EXTERNAL SIGMASDLL;
Function SM_GetIntArray(var A:ArrayIntType; Count:Integer):Integer;    cdecl;    EXTERNAL SIGMASDLL;
Function SM_PutByteArray(var A:ArrayType; Count:Integer):Integer;      cdecl;    EXTERNAL SIGMASDLL;
Function SM_PutSIntArray(var A:ArraySIntType; Count:Integer):Integer;  cdecl;    EXTERNAL SIGMASDLL;
Function SM_PutIntArray(var A:ArrayIntType; Count:Integer):Integer;     cdecl;    EXTERNAL SIGMASDLL;
Function SM_DSPFuncRx(FuncNum:Integer):Integer; cdecl;  cdecl;    EXTERNAL SIGMASDLL;





Procedure UpdateIntensities;
Begin

End;

procedure TForm1.Button1Click(Sender: TObject);
begin
   OpenDialog1.Filter:='*.OUT|*.OUT';
   if OpenDialog1.Execute then
   Begin
      Edit1.Text:=OpenDialog1.FileName;
   End;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   SM_Close;
   SM_Initialize(Edit1.Text);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
   Close;
end;







procedure TForm1.FormCreate(Sender: TObject);
begin
   Hdll:=0; //Initialize...
   Hdll:=LoadLibrary(PChar('SIGMASDLL.dll'#0));
   If Hdll=0 then ShowMessage('Error Loading IHSInterface DLL Library');
end;



procedure TForm1.FormShow(Sender: TObject);
var ts:String;
begin
   if ParamCount>=1 then
   Begin
      ts:=ParamStr(1);
      if FileExists(ts) then
      Begin
         Edit1.Text:=ts;
         SM_Initialize(Edit1.Text);
         if (ParamCount=2) and (ParamStr(2)='[CLOSE]') then Halt;
      End;
   End;
end;


end.
